Texture2D<uint> ObjectTexture;
Texture2D TrackingTexture;

RWStructuredBuffer<uint> RWHitCountBuffer : BACKBUFFER;

float minluma = 0.5f;

[numthreads(64, 1, 1)]
void CS_Clear( uint3 i : SV_DispatchThreadID)
{ 
	RWHitCountBuffer[i.x] = 0;
}

[numthreads(8, 8, 1)]
void CS( uint3 i : SV_DispatchThreadID)
{ 
	uint w,h, dummy;
	TrackingTexture.GetDimensions(0,w,h,dummy);
	if (i.x >= w || i.y >= h) { return; }
		
	float trackingcolor = TrackingTexture[i.xy].r;
	uint objectid = ObjectTexture[i.xy];
	
	if (trackingcolor > minluma && objectid > 0)
	{
		uint oldval;
		InterlockedAdd(RWHitCountBuffer[objectid-1],1,oldval);
	}

}

technique11 Clear
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS_Clear() ) );
	}
}

technique11 ProcessTexture
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}








